!ABCIncludeFile

  OMIT('_EndOfInclude_',_JSRTimer_Present_)

_JSRTimer_Present_   EQUATE(1)

!========================================================================================
! JSR_TimerClass Definitions
!========================================================================================

JSR__TimerQType     QUEUE,TYPE
ID                      LONG            ! A unique ID for each timer
FireTime                LONG            ! CLOCK value at which this timer should fire
FireDate                LONG            ! TODAY value at which this timer should fire
Interval                LONG            ! How often does this timer fire (1/100th of a seconds) - 0 if the timer is off
DefaultInterval         LONG            ! Interval to use when the timer is turned on
Title                   CSTRING(60)     ! A Title for this timer
Locked                  LONG            ! True if this timer is locked on and can not be turned off by the AllOff Method
                                        ! If so, it must be explicitly turned Off
                    END

JSR_TimerClass      CLASS,TYPE,MODULE('JSRTIMER.CLW'),LINK('JSRTIMER.CLW',_ABCLinkMode_)
SelfName                STRING(40)  ! Under template control will identify the name of the instance of this object
WindowRef               &WINDOW     ! Reference to the users window
LastID                  LONG        ! The last ID used by the AddTimer method
OriginalTimer           LONG        ! Original Windows Timer
DisplayCtrl             LONG        ! Control used to display (using Prop:Text} the Title of the current ActiveTimer
ActiveTimer             LONG        ! The TimerQ.ID that is currently Active
TimerQ                  &JSR__TimerQType            ! Our queue of timers
AddTimer                PROCEDURE(long pDefaultInterval, string pTitle),LONG
AllOff                  PROCEDURE                   ! Turns off all timers except those that are Locked on
CheckTimers             PROCEDURE                   ! Checks to see if timers should fire
FindID                  PROCEDURE(long pID),LONG    ! Finds a specific timer ID
Init                    PROCEDURE(Window pWindow)   ! Initializes the Object
Kill                    PROCEDURE                   ! Kills the object
Kill                    PROCEDURE(long pID)         ! Kills a specific timer queue entry after looking up the ID
KillOne                 PROCEDURE                   ! Kills the timer queue entry that is in memory
Off                     PROCEDURE(long pID)         ! Turns off a Specific Timer
On                      PROCEDURE(long pID,<long pLock>)                    ! Turns on a specific Timer
SetTimer                PROCEDURE(long pID, long pInterval, <long pLock>)   ! Changes the interval for a specific timer

_Add_My_Timers          PROCEDURE                   ! Internal method called by Init to add the timers
Add_My_Timers           PROCEDURE,VIRTUAL           ! Virtual method to be overridden by specific instance

_Timer_Proc             PROCEDURE                   ! Internal method called by CheckTimers when a timer proc is being fired
Timer_Proc              PROCEDURE,VIRTUAL           ! Virtual method to be overridden by specific instance
UsageError              PROCEDURE(string pMethod)   ! Displays an error if any methods are called before Init
                    END


 ! _EndOfInclude_





                  














